#ifndef _COMPASS_H
#define _COMPASS_H

#include <avr/io.h>
#include <avr/interrupt.h>

// compass address
#define COMPASS_ADDR           0x42

// compass commands
#define COMPASS_HEADING        0x41
#define COMPASS_START_CAL      0x43
#define COMPASS_STOP_CAL       0x45

void compass_init(void);
void compass_start(void);
void compass_stop(void);
void compass_start_calibration(void);
void compass_stop_calibration(void);
void compass_set_num_samples(uint8_t num);
void compass_loop(void);

#endif
