#ifndef _DYN_COMMON_H
#define _DYN_COMMON_H

#include <avr/io.h>
#include <avr/interrupt.h>

// Instruction identifiers
#define INST_PING           0x01
#define INST_READ           0x02
#define INST_WRITE          0x03
#define INST_REG_WRITE      0x04
#define INST_ACTION         0x05
#define INST_RESET          0x06
#define INST_SYNC_READ      0x82
#define INST_SYNC_WRITE     0x83
#define INST_BULK_READ      0x92
#define INST_BULK_WRITE     0x93

// bus errors
#define INSTRUCTION_ERROR   0x40
#define OVERLOAD_ERROR      0x20
#define CHECKSUM_ERROR      0x10
#define RANGE_ERROR         0x08
#define OVERHEATING_ERROR   0x04
#define ANGLE_LIMIT_ERROR   0x02
#define VOLTAGE_ERROR       0x01
#define NO_ERROR            0x00

uint8_t do_write(uint8_t address,uint8_t length,uint8_t *data);
uint8_t do_read(uint8_t address,uint8_t length,uint8_t **data);

#endif
