#ifndef _PORTS_H
#define _PORTS_H

#define NUM_GPIO 19

#define INPUT 0x00
#define OUTPUT 0x01

typedef struct
{
  volatile uint8_t *dir_reg;
  volatile uint8_t *write_reg;
  volatile uint8_t *read_reg;
  uint8_t bit;
}TGPIO;

void init_ports(void);
void config_port(uint8_t port_id,uint8_t dir);
uint8_t get_port_config(uint8_t port_id);
void set_port(uint8_t port_id);
void clear_port(uint8_t port_id);
uint8_t read_port(uint8_t port_id);
void set_led(void);
void clear_led(void);
void toggle_led(void);
uint8_t get_selector_value(void);
void ports_loop(void);

#endif
